﻿Type=Class
Version=2.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private parser As SaxParser
	Private dicts As List
	Private currentKey As String
	Private currentDict As Map
	Private currentArray As List
	Private insideDict As Boolean
	Private insideArray As Boolean
End Sub

Public Sub Initialize
	parser.Initialize
End Sub

Public Sub Parse (In As InputStream) As List
	dicts.Initialize
	parser.Parse(In, "parser")
	Return dicts
End Sub
Sub Parser_StartElement (Uri As String, Name As String, Attributes As Attributes)
	If Name = "dict" AND parser.Parents.Size = 3 Then
		Dim currentDict As Map
		currentDict.Initialize
		insideDict = True
	End If
	If insideDict AND Name = "array" Then
		Dim currentArray As List
		currentArray.Initialize
		insideArray = True
	End If
End Sub

Sub Parser_EndElement (Uri As String, Name As String, Text As StringBuilder)
	If insideArray AND Name = "string" Then
		currentArray.Add(Text.ToString)
	Else If insideDict Then
		If Name = "key" Then 
			currentKey = Text.ToString
		Else If Name = "string" OR Name = "integer" Then
			currentDict.Put(currentKey, Text.ToString)
		Else If Name = "true" Then
			currentDict.Put(currentKey, True)
		Else If Name = "false" Then
			currentDict.Put(currentKey, False)
		Else If Name = "array" Then
			currentDict.Put(currentKey, currentArray)
			insideArray = False
		End If
	End If
	If Name = "dict" AND parser.Parents.Size = 3 Then
		dicts.Add(currentDict)
		insideDict = False		
	End If
End Sub